.586
.MMX
.MODEL	FLAT,STDCALL

includelib	kernel32.lib

extrn	_imp__ExitProcess@4:DWORD


.DATA
src	DD	0,-1,-1,80808080h
dst	DD	0,0,-1,30201000h


.CODE
start:
	xor	ebx,ebx

	push	800080h
	push	800080h
	push	5	;;LENGTHOF dst		;;24b<->32b
	push	OFFSET dst
	push	OFFSET src
	call	Blend24

	push	ebx
	call	_imp__ExitProcess@4


OPTION	PROLOGUE:NONE
OPTION	EPILOGUE:NONE

Blend32	PROC	arg1:DWORD, arg2:DWORD, arg3:DWORD, arg4:QWORD
pSrc	EQU	DWORD PTR [esp + 4]
pDst	EQU	DWORD PTR [esp + 8]
cARGB	EQU	DWORD PTR [esp + 12]
factor	EQU	QWORD PTR [esp + 16]

	mov	ecx,cARGB			;;pix count
	test	ecx,ecx
	jz	fin
	movq	mm0,factor

	pcmpeqd	mm1,mm1
	psrlw	mm1,15
	psllw	mm1,8

	movq	mm2,mm0

	pcmpgtw	mm0,mm1
	packsswb	mm0,mm0
	movd	eax,mm0
	test	eax,eax
	jnz	fail

	mov	edx,pSrc			;;Src
	mov	eax,pDst			;;Dst

	sub	edx,4
	sub	eax,4

	movq	mm0,mm2				;;factor
	pxor	mm2,mm2				;;0
	psubusw	mm1,mm0				;;256-factor
@@:
	movd	mm3,[edx + ecx*4]
	movd	mm4,[eax + ecx*4]
	punpcklbw	mm3,mm2
	punpcklbw	mm4,mm2
	pmullw	mm3,mm1
	pmullw	mm4,mm0
	paddusw	mm3,mm4
	psrlw	mm3,8
	packuswb	mm3,mm2
	movd	[eax + ecx*4],mm3
	dec	ecx
	jnz	@B

	emms
fin:	or	eax,-1
	ret	20
fail:
	emms
	xor	eax,eax
	ret	20
Blend32	ENDP

OPTION	EPILOGUE:EPILOGUEDEF
OPTION	PROLOGUE:PROLOGUEDEF


OPTION	PROLOGUE:NONE
OPTION	EPILOGUE:NONE

Blend24	PROC	arg1:DWORD, arg2:DWORD, arg3:DWORD, arg4:QWORD
pSrc	EQU	DWORD PTR [esp + 4]
pDst	EQU	DWORD PTR [esp + 8]
cRGB	EQU	DWORD PTR [esp + 12]
factor	EQU	QWORD PTR [esp + 16]

	mov	ecx,cRGB			;;pix count
	test	ecx,ecx
	jz	fin

	movq	mm0,factor
	psllq	mm0,16
	psrlq	mm0,16				;;0-R-G-B

	pcmpeqd	mm1,mm1
	psrlw	mm1,15
	psllw	mm1,8

	movq	mm2,mm0				;;0-R-G-B

	pcmpgtw	mm0,mm1
	packsswb	mm0,mm0
	movd	eax,mm0
	test	eax,eax
	jnz	fail

	movq	mm0,mm1
	psllq	mm0,48				;;higher byte of dst preserved

	mov	edx,pSrc			;;Src
	mov	eax,pDst			;;Dst

	por	mm0,mm2				;;factor
	pxor	mm2,mm2				;;0
	psubusw	mm1,mm0				;;256-factor
@@:
	movd	mm3,[edx]
	movd	mm4,[eax]
	punpcklbw	mm3,mm2
	punpcklbw	mm4,mm2
	pmullw	mm3,mm1
	pmullw	mm4,mm0
	paddusw	mm3,mm4
	psrlw	mm3,8
	packuswb	mm3,mm2
	movd	[eax],mm3

	add	edx,3
	add	eax,3
	dec	ecx
	jnz	@B

	emms
fin:	or	eax,-1
	ret	20
fail:
	emms
	xor	eax,eax
	ret	20
Blend24	ENDP

OPTION	EPILOGUE:EPILOGUEDEF
OPTION	PROLOGUE:PROLOGUEDEF


END	start